//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-station.cm"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_minimum 0
#property indicator_maximum 5
#property strict

//
//
//
//
//

enum enTimeFrames
{
   tf_cu  = PERIOD_CURRENT, // Current time frame
   tf_m1  = PERIOD_M1,      // 1 minute
   tf_m5  = PERIOD_M5,      // 5 minutes
   tf_m15 = PERIOD_M15,     // 15 minutes
   tf_m30 = PERIOD_M30,     // 30 minutes
   tf_h1  = PERIOD_H1,      // 1 hour
   tf_h4  = PERIOD_H4,      // 4 hours
   tf_d1  = PERIOD_D1,      // Daily
   tf_w1  = PERIOD_W1,      // Weekly
   tf_mn1 = PERIOD_MN1,     // Monthly
   tf_n1  = -1,             // First higher time frame
   tf_n2  = -2,             // Second higher time frame
   tf_n3  = -3              // Third higher time frame
};
extern enTimeFrames       TimeFrame1            = tf_cu;                       // First time frame
extern enTimeFrames       TimeFrame2            = tf_n1;                       // Second time frame
extern enTimeFrames       TimeFrame3            = tf_n2;                       // Third time frame
extern enTimeFrames       TimeFrame4            = tf_n3;                       // Fourth time frame
extern int                Rsiperiod             = 7;                           // Rsi period
extern ENUM_APPLIED_PRICE Price                 = PRICE_CLOSE;                 // Rsi price
extern int                Levelup               = 60;                          // Up level
extern int                Leveldown             = 40;                          // Down level
extern string             UniqueID              = "4 Time frame RSI 2 Levels"; // Unique ID
extern bool               alertsOn              = false;                       // Turn alerts on?
extern int                alertsLevel           = 3;                           // Alerts level
extern bool               alertsMessage         = false;                       // Alerts message?
extern bool               alertsSound           = false;                       // Alerts sound?
extern bool               alertsEmail           = false;                       // Alerts email?
extern int                LinesWidth            = 0;                           // Lines width
extern color              LabelsColor           = clrDarkGray;                 // Lines color
extern int                LabelsHorizontalShift = 5;                           // Labels horizontal shift
extern double             LabelsVerticalShift   = 1.5;                         // Labels vertical shift
extern color              ColorUp               = clrDodgerBlue;               // Color for up
extern color              ColorDown             = clrSandyBrown;               // Color for down

//
//
//
//
//

double rsi1u[],rsi1d[],rsi2u[],rsi2d[],rsi3u[],rsi3d[],rsi4u[],rsi4d[],count[];

int    timeFrames[4];
string indicatorFileName;
bool   returnBars;
#define _mtfCall(_tf,_buff,_ind) iCustom(NULL,_tf,indicatorFileName,0,-99,_buff,_ind)

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(9);
   SetIndexBuffer(0,rsi1u);
   SetIndexBuffer(1,rsi1d);
   SetIndexBuffer(2,rsi2u);
   SetIndexBuffer(3,rsi2d);
   SetIndexBuffer(4,rsi3u);
   SetIndexBuffer(5,rsi3d);
   SetIndexBuffer(6,rsi4u);
   SetIndexBuffer(7,rsi4d);
   SetIndexBuffer(8,count);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame2==-99); 
      
      //
      //
      //
      //
      //
      
      for (int i=0; i<8; i++) 
      {
         SetIndexStyle(i,DRAW_ARROW,EMPTY,LinesWidth,i%2==0?ColorUp:ColorDown); SetIndexArrow(i,110); 
      }
      timeFrames[0] = timeFrameValue(TimeFrame1);
      timeFrames[1] = timeFrameValue(TimeFrame2);
      timeFrames[2] = timeFrameValue(TimeFrame3);
      timeFrames[3] = timeFrameValue(TimeFrame4);
      alertsLevel = MathMin(MathMax(alertsLevel,3),4);
      IndicatorShortName(UniqueID);
   return(0);
}
int deinit() { ObjectsDeleteAll(0,UniqueID); return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double trend[][2];
#define _up 0
#define _dn 1
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1); count[0] = limit; if (returnBars) return(0);
         if (timeFrames[0] != !_Period) limit = (int)MathMax(limit,MathMin(Bars-1,_mtfCall(timeFrames[0],8,0)*timeFrames[0]/_Period));
         if (timeFrames[1] != !_Period) limit = (int)MathMax(limit,MathMin(Bars-1,_mtfCall(timeFrames[1],8,0)*timeFrames[1]/_Period));
         if (timeFrames[2] != !_Period) limit = (int)MathMax(limit,MathMin(Bars-1,_mtfCall(timeFrames[2],8,0)*timeFrames[2]/_Period));
         if (timeFrames[3] != !_Period) limit = (int)MathMax(limit,MathMin(Bars-1,_mtfCall(timeFrames[3],8,0)*timeFrames[3]/_Period));
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);

         //
         //
         //
         //
         //
         
         bool initialized = false;
         if (!initialized)
         {
            initialized = true;
            int window = WindowFind(UniqueID);
            for (int t=0; t<4; t++)
            {
               string label = timeFrameToString(timeFrames[t]);
               ObjectCreate(UniqueID+(string)t,OBJ_TEXT,window,0,0);
                  ObjectSet(UniqueID+(string)t,OBJPROP_COLOR,LabelsColor);
                  ObjectSet(UniqueID+(string)t,OBJPROP_PRICE1,t+LabelsVerticalShift);
                  ObjectSetText(UniqueID+(string)t,label,8,"Arial");
            }               
         }
         for (int t=0; t<4; t++) ObjectSet(UniqueID+(string)t,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

   //
   //
   //
   //
   //
    
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      trend[r][_up] = 0;
      trend[r][_dn] = 0;
      for (int k=0; k<4; k++)
      {
         int y = iBarShift(NULL,timeFrames[k],Time[i]);
            double rsi = iRSI(NULL,timeFrames[k],Rsiperiod,Price,y);
            bool isUp = (rsi>Levelup);
            switch (k)
            {
               case 0 : rsi1d[i] = EMPTY_VALUE; rsi1u[i] = EMPTY_VALUE; if (isUp && rsi>Levelup) rsi1u[i] = k+1; if (!isUp && rsi<Leveldown) rsi1d[i] = k+1;  break;
               case 1 : rsi2d[i] = EMPTY_VALUE; rsi2u[i] = EMPTY_VALUE; if (isUp && rsi>Levelup) rsi2u[i] = k+1; if (!isUp && rsi<Leveldown) rsi2d[i] = k+1;  break;
               case 2 : rsi3d[i] = EMPTY_VALUE; rsi3u[i] = EMPTY_VALUE; if (isUp && rsi>Levelup) rsi3u[i] = k+1; if (!isUp && rsi<Leveldown) rsi3d[i] = k+1;  break;
               case 3 : rsi4d[i] = EMPTY_VALUE; rsi4u[i] = EMPTY_VALUE; if (isUp && rsi>Levelup) rsi4u[i] = k+1; if (!isUp && rsi<Leveldown) rsi4d[i] = k+1;  break;
            }
            if (isUp)
                  trend[r][_up] += 1;
            else  trend[r][_dn] += 1;
      }
   }
   manageAlerts();
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = Bars-1;
      if (trend[whichBar][_up] >= alertsLevel || trend[whichBar][_dn] >= alertsLevel)
      {
         if (trend[whichBar][_up] >= alertsLevel) doAlert("up"  ,(int)trend[whichBar][_up]);
         if (trend[whichBar][_dn] >= alertsLevel) doAlert("down",(int)trend[whichBar][_dn]);
      }
   }
}

//
//
//
//
//

void doAlert(string doWhat, int howMany)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" "+(string)howMany+" time frames of RSI are aligned "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" 4 time frame RSI",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int timeFrameValue(int _tf)
{
   int add  = (_tf>=0) ? 0 : MathAbs(_tf);
   if (add != 0) _tf = _Period;
   int size = ArraySize(iTfTable); 
      int i =0; for (;i<size; i++) if (iTfTable[i]==_tf) break;
                                   if (i==size) return(_Period);
                                                return(iTfTable[(int)MathMin(i+add,size-1)]);
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}